Module com.io7m.jtensors.core
Package com.io7m.jtensors.core.unparameterized.vectors

## Class Vector4D

- java.lang.Object
- - com.io7m.jtensors.core.unparameterized.vectors.Vector4D

- All Implemented Interfaces:
    `Vector4DType`, `VectorReadable2DType`, `VectorReadable3DType`, `VectorReadable4DType`, `VectorComputationalType`

      public final class Vector4D
      extends Object
      implements Vector4DType

  The type of 4D `double`-typed vectors.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class | Description
    --- | --- | ---
    `static class` | `Vector4D.Builder` | Builds instances of type `Vector4D`.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static Vector4D.Builder` | `builder​()` | Creates a builder for `Vector4D`.
    `boolean` | `equals​(Object another)` | This instance is equal to all instances of `Vector4D` that have equal attribute values.
    `int` | `hashCode​()` | Computes a hash code from attributes: `x`, `y`, `z`, `w`.
    `static Vector4D` | `of​(double x, double y, double z, double w)` | Construct a new immutable `Vector4D` instance.
    `String` | `toString​()` | Prints the immutable value `Vector4D` with attribute values.
    `double` | `w​()` |
    `double` | `x​()` |
    `double` | `y​()` |
    `double` | `z​()` |

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Method Detail

    - #### x

          public double x​()

      Specified by:
        `x` in interface `Vector4DType`
      Specified by:
        `x` in interface `VectorReadable2DType`
      Returns:
        The value of the `x` attribute

    - #### y

          public double y​()

      Specified by:
        `y` in interface `Vector4DType`
      Specified by:
        `y` in interface `VectorReadable2DType`
      Returns:
        The value of the `y` attribute

    - #### z

          public double z​()

      Specified by:
        `z` in interface `Vector4DType`
      Specified by:
        `z` in interface `VectorReadable3DType`
      Returns:
        The value of the `z` attribute

    - #### w

          public double w​()

      Specified by:
        `w` in interface `Vector4DType`
      Specified by:
        `w` in interface `VectorReadable4DType`
      Returns:
        The value of the `w` attribute

    - #### equals

          public boolean equals​(Object another)

      This instance is equal to all instances of `Vector4D` that have equal attribute values.
      Overrides:
        `equals` in class `Object`
      Returns:
        `true` if `this` is equal to `another` instance

    - #### hashCode

          public int hashCode​()

      Computes a hash code from attributes: `x`, `y`, `z`, `w`.
      Overrides:
        `hashCode` in class `Object`
      Returns:
        hashCode value

    - #### toString

          public String toString​()

      Prints the immutable value `Vector4D` with attribute values.
      Overrides:
        `toString` in class `Object`
      Returns:
        A string representation of the value

    - #### of

          public static Vector4D of​(double x,
                                    double y,
                                    double z,
                                    double w)

      Construct a new immutable `Vector4D` instance.
      Parameters:
        `x` - The value for the `x` attribute
        `y` - The value for the `y` attribute
        `z` - The value for the `z` attribute
        `w` - The value for the `w` attribute
      Returns:
        An immutable Vector4D instance

    - #### builder

          public static Vector4D.Builder builder​()

      Creates a builder for `Vector4D`.
      Returns:
        A new Vector4D builder

Copyright © 2017 <code@io7m.com> http://io7m.com